#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
using namespace std;


//проверка на сущность если возвращает 1 - то это сущность , иначе - свойство сущности
int is_entity(string str){
	string sushnost[]={"сеть", "нейрон", "синапс"};
	int f=0;
	for(int i=0;i<3;i++){
		if(str.find(sushnost[i])!=string::npos) f=1;
	}

	return f;

}
//проверка тега 1 открывающий 0 - закрывающий
int open_or_close(string str){

	int f=1;
	if(str.find('/')!=string::npos) f=0;
	return f;

}

int id_check(char* filename){

	ifstream ver;
	ver.open(filename);
	if(!ver.is_open()) cout <<"Ошибка, не удалось открыть файл\n";
	string id[1000];
	string str;
	ver.seekg(0,ver.beg);
	int i=0;
	for(char c; ver.get(c); ){

		if(('<') == c)
		{
			for(; ver.get(c) && '>' != c; str += c)
				;
			if(str.find("идентификатор")!=string::npos &&  str.find("/идентификатор")==string::npos){
				str.clear();
				for(; ver.get(c) && '<' != c; str += c)
					;
				id[i]=str;
				i++;
			}	

		}

	}
	for(int l=0;l<i;l++){
		for(int k=0;k<i;k++){
			if (k!=l && id[k]==id[l]){
				cout <<"Ошибка, идентификатор "<< id[l] << " встречается более одного раза"<< endl;
				ver.close();
				return 0;
			}
		}
	}
	ver.close();
	return 1;
}
//проверка допустимых тегов
int check_of_admissible_tags(char* filename){
	
	ifstream ver,dic;
	ver.open(filename);
	if(!ver.is_open()) cout <<"Ошибка, не удалось открыть проверяемый файл\n";
	dic.open("source/dictionary.txt");
	if(!dic.is_open()) cout <<"Ошибка, не удалось открыть файл-словарь\n";
	string str;
	str.clear();

	string tags[50];
	int i=0;
	tags[0].clear();
	for(char c; dic.get(c); ){
		if(c!='\n') {
			tags[i]+=c;
		}
		else{
			i++;
			tags[i].clear();
			
		}
	}
	int f=0;//флаг для определения наличия лишнего тега
	for(char c; ver.get(c); ){
		if(('<') == c)
		{	
			for(; ver.get(c) && '>' != c; str += c)
		
				;
			for(int j=0;j<i;j++){

				if(tags[j].find(str.substr(1,5))!=string::npos) f++;
			}//cout  << str << endl;
			if(f==0){cout <<"Обнаружен недопустимый тег: "<< str << "\n"; return 0;}
		}
		str.clear();
		f=0;
	}
}

//форматируем хмл 

int format_xml(char *filename1){//файл1 - исходник, 2й - форматированный

	ifstream file1;
	ofstream file2;
	string str;


	file1.open(filename1);
	if(!file1.is_open()) cout <<"Ошибка, не удалось открыть исходный файл\n";
	file2.open("format_xml.insml");
	if(!file2.is_open()) cout <<"Ошибка, не удалось открыть/создать преобразованый файл\n";

	for(char c; file1.get(c); str.clear()){
		if(('<') == c){
			str+='<';
			for(; file1.get(c) && '>' != c; str += c)
				;
			str+='>';
			}
			
			if(!str.empty()){
				if(is_entity(str) && (str.find("сеть")!=string::npos) && open_or_close(str)){
					file2 << str << endl;
					
					
					continue;
					
					}
				else if(is_entity(str) && !open_or_close(str) && str.find("сеть")!=string::npos){
			
					file2 << str << endl;
					file2 << "  "; 
					
					continue;
					}
				else if(is_entity(str) && str.find("сеть")==string::npos){
					file2 << "  ";		
			
					file2 << str << endl;
					continue;			
							
					}
			
				else if(!is_entity(str) && open_or_close(str)){
					file2 << "    ";
					file2 << str; str.clear();
					for(; file1.get(c) && '>' != c; str += c);

					file2 << str << ">" << endl;
					continue;
						}
				}
		

			
	}
	file1.close();
	file2.close();

}
int open_close_tag(char* filename){

	string str;
	ifstream file;
	file.open(filename);
	if(!file.is_open()) cout <<"Ошибка, не удалось открыть исходный файл\n";
	int NumberOfString=1;
	int net=0, entity=0, tag=0;//флаги для тегов =  сеть . сущность . тег 
	for(char c; file.get(c); str.clear()){
		if(('<') == c){
			for(; file.get(c) && '>' != c; str += c)
				;
			
/*тут такая задумка что: читаем до открывающего тега, допустим "дата" - тогда tag=1, и если при чтении далее мы снова натыкаемя на открывающий тег при tag==1 то выдается ошибка*/
			//для открывающих тегов
			if(str.find("сеть")!=string::npos && str.find("/")==string::npos) {
				net=1;
			}
			if(is_entity(str) && open_or_close(str) && str.find("сеть")==string::npos){
				if(entity==1 && net==1){cout << "\n Ошибка: перед тегом "<< "\"" << str << "\" " << "на строке: " << NumberOfString << ", отсутствует закрывающий тег" << endl;return 0;}
				entity=1;
			}
			if(!is_entity(str) && open_or_close(str)){
				if(tag==1 && net==1){cout << "\n Ошибка: перед тегом "<< "\"" << str << "\" " << "на строке: " << NumberOfString << ", отсутствует закрывающий тег" << endl;return 0;}
				tag=1;
			}
			//для закрывающих тегов
			if(!is_entity(str) && !open_or_close(str)){
				if(tag==0 && net==1){cout << "\n Ошибка: перед тегом "<< "\"" << str << "\" " << "на строке: " << NumberOfString << ", отсутствует открывающий тег" << endl;return 0;}
				tag=0;
			}
			if(is_entity(str) && !open_or_close(str) && str.find("сеть")==string::npos){
				if(entity==0 && net==1){cout << "\n Ошибка: перед тегом "<< "\"" << str << "\" " << "на строке: " << NumberOfString << ", отсутствует открывающий тег" << endl;return 0;}
				entity=0;
			}
			if(str.find("сеть")!=string::npos && str.find("/")!=string::npos) {
				if(net==0 && net==1) {cout << "Ошибка: нет открывающего тега сеть"<< endl;return 0;}
				net=0;
			}
		}
		else if('\n'==c) NumberOfString++;
			str.clear();
		}
}

int main(int argc, char* argv[])
{	int x;
	if(argc<2){
		cout << "Функции осуществляют проверку уникальности идентификаторов элементов сети, проверку на наличие недопустимых тегов и форматирование/структурирование исходного текста \"insml\"" << endl;
	//	cout << "Введите аргументы: \n для проверки допустимых тегов - файл входа \n для форматирования xml'a - файл входа \n для проверки id - файл входа \n для проверки на наличие открывающих закрывающих тегов - файл входа \n" ;
		return 0;
	}
	cout << "Выберите какю функцию использовать:\n 1 - проверка допустимых тегов \n 2 - форматирование \n 3 - проверка идентификатора\n 4 - проверка на наличие открывающих/закрывающих тегов \n" << endl;
	cin >> x;
	if(strstr(argv[1],".insml")!=NULL){
		switch(x){
		case 1:{ check_of_admissible_tags(argv[1]); break; }
		case 2:{ format_xml(argv[1]); break; }
		case 3:{ id_check(argv[1]); break; }
		case 4:{ open_close_tag(argv[1]); break;}
	}
	}
	return 0;
}