#include <iostream>
#include <fstream>
#include <cstring>
#include <cstdlib>

using namespace std;

void help_message() {
  cout << "Выберите ключ и аргументы:" << endl;
  cout << "-v file.insml проверка на допустимые теги" << endl;
  cout << "-t source_file.insml result_file.insml перевод на другой язык" << endl;
}

int main(int argc, char *argv[]) {
  if (argc == 1) {
    help_message();
    return 0;
  }

  char * path = new char[1000];
  memset((void*)path,0,sizeof(char)*1000);
  if (argc == 2) {
    //Верификатор
    if (argv[1][1] == 'v') {
      strcpy(path, "bin/verificator");
      system(path);
      return 0;
    }
    //Переводчик
    if (argv[1][1] == 't') {
      strcpy(path, "bin/translator");
      system(path);
      return 0;
    }
  }
  //Верифицируем
  if ((argv[1][1] == 'v') && (argc == 3)) {
    strcpy(path, "bin/verificator ");
    strcat (path, argv[2]);
    system(path);
    return 0;
  }
  //Переводим
  if ((argv[1][1] == 't') && (argc == 4)) {
    strcpy(path, "bin/translator ");
    strcat (path, argv[2]);
    strcat (path, " ");
    strcat (path, argv[3]);
    system(path);
    return 0;
  }

  //Завершаем
  delete [] path;
  return 0;
}
